#!python
## DONT EDIT THIS
import pypuck
import canopen as co
import time
## END DONT EDIT THIS

## CHANGE THESE VALUES AS NEEDED
NodeId = 1 # Change the node id here
CONTROL_RATE = .004 # Change the control rate
TargetVelocity = 10*4096 # In counts per second at input shaft 4096 counts per rotation of the motor at input shaft

## DONT EDIT THIS
active_puck = None

def control(msg):
    active_puck.rpdo(1)["VelTargetVelocity"].raw = TargetVelocity
    active_puck.rpdo(1).transmit()
    print("temperature: {0:0.2f}, velocity: {1}".format(msg["AmplifierTemperature"].raw/256.0, msg["VelActualValue"].raw))

try:
    network = co.Network()
    network.connect(bustype='pcan', channel='PCAN_USBBUS1', bitrate=1000000)
    pucks = pypuck.scan_for_pucks(network)
    active_puck = None
    for puck in pucks:
        if puck.node_id == NodeId:
            active_puck = puck
    active_puck.add_to_network(network)

    network.sync.start(CONTROL_RATE)

    active_puck.reset_ds402()


    active_puck.set_mode("velocity")

    active_puck.read_pdos()
    active_puck.set_rpdo(1, ["TargetPosition", "VelTargetVelocity"])
    active_puck.set_tpdo(1, ["VelActualValue", "AmplifierTemperature"])
    active_puck.tpdo(1).add_callback(control)

    time.sleep(10)
finally:
    network.disconnect()
##